%% Copyright (c) Cosmo Luca - luca.cosmo@unive.it
%  SHREC2016 - Partial Matching Of Deformable Shapes
%  http://www.dais.unive.it/~shrec2016/

type = 'holes'; %dataset name [cuts|holes]
base_dir = '../shrec2016_PartialDeformableShapes'; %directory conatining the datasets subfolders (cuts/holes/null) 

null_dir = sprintf('%s/%s/',base_dir,'null');
part_dir = sprintf('%s/%s/',base_dir,type);

files = dir([part_dir,'*.off']);

for fi = 1:numel(files)
    fprintf('-------------------------------------\n');
    fprintf('Loading shape %d of %d\n',fi, numel(files));
    
    fname = [files(fi).name];
    [~, part_name, ~] = fileparts(fname);
    
    model = regexp(part_name,'[^_0-9]*','match');
    model = [model{2}];
    
    M = load_off([null_dir model '.off']);
    N = load_off([part_dir part_name '.off']);
    
    N.baryc_gt = load([part_dir, part_name,'.baryc_gt']);
    N.baryc_gt_sym = load([part_dir, part_name,'.baryc_gt_sym']);
   
    fprintf('Rendering shape %d of %d\n',fi, numel(files));
    model_color = M.VERT(:,1); %use X coordinate as vertex color
    %transfer the color fromt he model to opartial shapes using the
    %ground-truth barycentric weights
    part_color     = dot(reshape(model_color(M.TRIV(N.baryc_gt(:,1),:)),size(N.baryc_gt,1),3)',N.baryc_gt(:,2:4)');
    part_color_sym = dot(reshape(model_color(M.TRIV(N.baryc_gt_sym(:,1),:)),size(N.baryc_gt_sym,1),3)',N.baryc_gt_sym(:,2:4)');
    
    figure;
    subplot(1,3,1)
    plot_scalar_map(M,model_color);
    subplot(1,3,2)    
    plot_scalar_map(N,part_color);    
    subplot(1,3,3)    
    plot_scalar_map(N,part_color_sym);        
    drawnow;
end

